package org.netkernel.layer1.endpoint;

import java.net.URI;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class HDSXpathAccessor extends StandardAccessorImpl
{
	public HDSXpathAccessor()
	{	this.declareThreadSafe();
		this.declareSourceRepresentation(IHDSNode.class);
		this.declareSourceRepresentation(String.class);
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{	IHDSNode n=(IHDSNode)aContext.source("arg:operand", IHDSNode.class);
		String xpath=aContext.getThisRequest().getArgumentValue("operator");
		URI u=URI.create(xpath);
		if(u.isAbsolute())
		{	xpath=(String)aContext.source("arg:operator", String.class);			
		}
		Object result=null;
		boolean text=xpath.endsWith("/text()");
		if(text)
		{	xpath=xpath.substring(0,xpath.length()-7);
			result=n.getFirstValue(xpath);
			if(result!=null)
			{	result=result.toString();
			}
		}
		else
		{	IHDSNodeList nodes=n.getNodes(xpath);
			if(nodes.size()>1)
			{	throw aContext.createFormattedException("EX_HDSXPATH_MANY", null, xpath, null);	
			}
			else if(nodes.size()==0)
			{	throw aContext.createFormattedException("EX_HDSXPATH_NONE", null, xpath, null);	
			}
			else
			{	//Return a new HDS document rooted at selected node
				HDSBuilder b=new HDSBuilder();
				b.importNode(nodes.get(0));
				result=b.getRoot();
			}
		}
		aContext.createResponseFrom(result);
	}

}
