package org.netkernel.layer1.endpoint;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IBinaryStreamRepresentation;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.representation.impl.HDSFactory;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.w3c.dom.Node;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

/**
 * XML to HDS transreptor
 */
public class XMLToHDS extends StandardTransreptorImpl
{
	
	public XMLToHDS()
	{	this.declareThreadSafe();
		this.declareFromRepresentation(IBinaryStreamRepresentation.class);
		this.declareFromRepresentation(String.class);
		this.declareFromRepresentation(Node.class);
		this.declareToRepresentation( IHDSNode.class);
		this.declareName("XMLToHDS");
		this.declareDescription("Transrepts from XML to HDS");
	}
	
	public void onTransrept(INKFRequestContext aContext) throws Exception
	{	
		IHDSNode result;
		Object rawPrimary=aContext.getThisRequest().getPrimary();
		if (rawPrimary instanceof Node)
		{	result = HDSFactory.parseDOM((Node)rawPrimary);
		}
		else
		{	InputStream is;
			if(rawPrimary instanceof String)
			{	is=new ByteArrayInputStream(((String)rawPrimary).getBytes());
			}
			else
			{	IReadableBinaryStreamRepresentation rbs=aContext.sourcePrimary(IReadableBinaryStreamRepresentation.class);
				is=rbs.getInputStream();
			}
			result=HDSFactory.parseXML(is);
		}
		aContext.createResponseFrom(result);
	}
}