package org.netkernel.layer1.endpoint.hds;

import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class HDSXpath2Accessor extends StandardAccessorImpl
{
	public HDSXpath2Accessor()
	{	this.declareThreadSafe();
		this.declareArgument(new SourcedArgumentMetaImpl("operand",null,null,new Class[]{IHDSNode.class}));
		this.declareArgument(new SourcedArgumentMetaImpl("xpath",null,null,new Class[]{String.class}));
		this.declareSourceRepresentation(IHDSNodeList.class);
		this.declareSourceRepresentation(IHDSNode.class);
		this.declareSourceRepresentation(Boolean.class);
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{	IHDSNode operand=aContext.source("arg:operand",IHDSNode.class);
		String xpath=aContext.source("arg:xpath",String.class);
		IHDSNodeList nodelist=operand.getNodes(xpath);
		
		Class requestedRep=aContext.getThisRequest().getRepresentationClass();
		Object result;
		if (requestedRep==Boolean.class)
		{	result=nodelist.size()>0;
		}
		else if (requestedRep==IHDSNode.class)
		{	int s=nodelist.size();
			if (s==1)
			{	result=nodelist.getFirstNode();
			}
			else if (s==0) 
			{	throw aContext.createFormattedException("EX_HDSXPATH_NONE", null, null, null, null);
			}
			else
			{	throw aContext.createFormattedException("EX_HDSXPATH_MANY", null, null, null, null);
			}
		}
		else
		{	result=nodelist;
		}
		aContext.createResponseFrom(result);
	}
}
